#!/usr/bin/env python
# -*- encoding: utf8
"""
xfce panel plugin
"""
# External libraries
import gtk							# use gtk-library
import xfce4.panel				# to create xfce4 panel plugin
# Own libraries
import pyNM							# Communicates with NetworkManager
import pyNM.diskWireless		#
import pyNM.gtk2					# gtk2 widgets
import pyNM.gtk2.securityui	# gtk2 uis for key management
import pyNM.sysNetworkSpeed	# checks data throughput

# Connect to NM and setup internal communication
pynm = pyNM.init()

# Check data throuput
pyNM.sysNetworkSpeed.init( pynm )	# much output on info level 8

# Manage wireless configurations
pyNM.diskWireless.init( pynm )

# GUI handling security/encryption issuses
pyNM.gtk2.securityui.init( pynm )

# Icon showing current status
icon = pyNM.gtk2.Icon( pynm )

# Menu with available networks
menu = pyNM.gtk2.Menu( pynm )

# Button with status icon and menu plopping up on clicking it
button = gtk.Button()
button.set_image( icon )
button.connect( "clicked", menu.show )
button.show()

# Tooltip showing current status and speed
pyNM.gtk2.Tooltip( pynm, button )

# Speedbars showing current speed
speedbars = pyNM.gtk2.Speedbars( pynm )

# a table to arrange buttons and speedbars
table = gtk.Table( rows=1, columns=6, homogeneous=True )
table.set_border_width(0)
table.attach( button, 0, 4, 0, 1 )
table.attach( speedbars.barTx, 4, 5, 0, 1 )
table.attach( speedbars.barRx, 5, 6, 0, 1 )
table.show()

# create an xfce panel plugin
plugin = xfce4.panel.Plugin()

# Eventbox for making right mouse button action work on whole plugin
eb = gtk.EventBox()
eb.add( table )
eb.show()
plugin.add( eb )

# Add right mouse button action
plugin.add_action_widget( eb )
plugin.add_action_widget( button )

# Show plugin
plugin.show()

# Close plugin on destroy
plugin.connect("destroy", pynm.stop )

# Ready. Start plugin
pynm.run()