# -*- coding: utf-8

# import most important modules
from constants import *
from client  import Client
from service import Service
from Bindings import *

import gobject # for event loop

def init():
	import gobject
	global main_loop
	return pyNM()

class pyNM:
	def __init__(self):
	 self.main_loop = gobject.MainLoop()

	 """
	 Bindings:
	 event     notifiers
	 request   method
	 requests  list of methods (answer returned in a list)

	 To use a binding:
	 name.listen( func )	           # to act on events and requests
	 name.remove( func )            # to stop act
	 name( argname=argvalue, ... )  # to trigger a binding
	 """

	 self.status_changed = Event( "Status changed", "status","network" )
	 self.speed_changed = Event( "Speed changed", "rx", "tx" )
	 self.strength_changed = Event( "Strength changed", "strength" )
	 # activated by user:
	 self.network_activated = Event( "network activated", "network" )
	 self.devices_altered = Event( "devices altered", "appeared", "device" )
	 self.networks_altered = Event(
	 	"networks altered", "appeared", "device", "network" )
	 self.nm_error = Event( "connection error to NetworkManager", "message" )

	 self.network_info_update = Event(
	 	"New information about network from NM", "network" )

	 self.current_status = Request("Current status")

	 self.available_devices = Request("list devices")
	 self.active_device = Request("get active device")
	 self.active_network = Request("get active network","device")
	 self.available_networks = Request("list networks","device")
	 self.known_networks = Requests("list known networks")
	 self.complement_from_disk = Requests("complement from disk","network")
	 self.complement_from_nm = Requests("complement from nm","network")

	 self.ask_for_network_key = Request("Ask user for network key","network")
	 self.abort_network_key_question = Event("Abort network key question")

	 self.activate_network = Request("User activates network","network")

	 self.client = Client( self )
	 self.service = Service( self )

	def refresh(self):
		status = self.current_status()
		network=False
		if status==ACTIVE:
			device = self.client.active_device()
			network = self.active_network( device=device )
			if not network:
				network=device
		self.status_changed( status=status, network=network )

	def run(self):
		"Start eventhandling, servers,clients and graphic"
		self.refresh()
		self.main_loop.run()

	def stop(self,*unused):
		self.main_loop.quit()
