# -*- coding: utf-8

import sys

"""
	Prints messages to standard output.
	With possibillities to filter shown
	error messages.

	# setup
	import debug
	set_error_level( <int> )
	set_info_level( <int> )
	set_allowed_sources( <list> )
	set_all_sources_allowed( <bool> )

	# use
	info(  <int> info_level,  <str> source, <str> message )
	error( <int> error_level, <str> source, <str> message )
	exit(  <int> error,       <str> source, <str> message )=>exit system

"""


# Internal settings
##############################################
__settings = {
	 'error_level'         : 3
	,'info_level'          : 3
	,'allowed_sources'     : []
	,'all_sources_allowed' : True
	}


# Setup methods
################################################
def set_error_level( error_level ):
	__settings['error_level'] = error_level

def set_info_level( info_level ): __settings['info_level'] = info_level

def set_all_sources_allowed( all_sources_allowed ):
		__settings['all_sources_allowed'] = all_sources_allowed

def add_allowed_source( self, allowed_source ):
	if type(allowed_source) in ( string, unicode ):
		__settings['allowed_sources'].append( allowed_source )
	elif type(allowed_source) in ( list, tuple ):
		for src in allowed_source:
			add_allowed_source( src )


# Message methods
###############################################
def info( level, source, message ):
	if source_is_allowed( source ) \
	and level<__settings['info_level']:
		print ": %s %s"%(source,message)

def error( level, source, message ):
	if source_is_allowed( source ) \
	and level<__settings['error_level']:
		print "! %s %s"%(source,message)

def exit( error, source, message ):
	print ". %s %s"%(source,message)
	sys.exit( error )


# Check methods
##############################################
def source_is_allowed( source ):
	if __settings['all_sources_allowed'] \
	or source in __settings['allowed_sources']:
		return True
	else:
		return False
