# -*- coding: utf-8

"""
se /usr/include/wireless.h
och include/NetworkManager.h
"""

# KEY INFORMATION
####################
HEX_CHARS = '0123456789abcdefABCDEF'

# AUTH TYPES
#########################
#
NM_AUTH_TYPE_WPA_PSK_AUTO	= 0x00000000
NM_AUTH_TYPE_NONE				= 0x00000001
NM_AUTH_TYPE_WEP40			= 0x00000002
NM_AUTH_TYPE_WPA_PSK_TKIP	= 0x00000004
NM_AUTH_TYPE_WPA_PSK_CCMP	= 0x00000008
NM_AUTH_TYPE_WEP104			= 0x00000010
NM_AUTH_TYPE_WPA_EAP			= 0x00000020

NM_AUTH_TYPE_NAMES = {
	NM_AUTH_TYPE_WPA_PSK_AUTO	: "WPA PSK AUTO",
	NM_AUTH_TYPE_NONE				: "NONE",
	NM_AUTH_TYPE_WEP40			: "WEP 40",
	NM_AUTH_TYPE_WPA_PSK_TKIP	: "WPA PSK TKIP",
	NM_AUTH_TYPE_WPA_PSK_CCMP	: "WPA PSK CCMP",
	NM_AUTH_TYPE_WEP104			: "WEP 104",
	NM_AUTH_TYPE_WPA_EAP			: "WPA EAP",
}

# EAP Methods
#####################
#
NM_EAP_METHOD_MD5		= 0x00000001	# EAP-MD5
NM_EAP_METHOD_MSCHAP	= 0x00000002	# EAP-MSCHAPv2
NM_EAP_METHOD_OTP		= 0x00000004	# EAP-OTP
NM_EAP_METHOD_GTC		= 0x00000008	# EAP-GTC
NM_EAP_METHOD_PEAP	= 0x00000010	# EAP-PEAP
NM_EAP_METHOD_TLS		= 0x00000020	# EAP-TLS
NM_EAP_METHOD_TTLS	= 0x00000040	# EAP-TTLS

# WPA
#####################
#
IW_AUTH_WPA_VERSION_DISABLED = 0x00000001
IW_AUTH_WPA_VERSION_WPA      = 0x00000002
IW_AUTH_WPA_VERSION_WPA2     = 0x00000004

IW_ALG_OPEN_SYSTEM   = 0x01
IW_ALG_SHARED_KEY    = 0x02

# Från http://oss.sgi.com/archives/netdev/2004-06/msg00189.html
########################
#
CIPHER_PAIRWISE      = 1
CIPHER_GROUP         = 2

CIPHER_NONE          = 0
CIPHER_WEP40         = 1
CIPHER_TKIP          = 2
CIPHER_CCMP          = 4
CIPHER_WEP104        = 5

# Från http://lwn.net/Articles/100130/
#######################3
#
IW_AUTH_KEY_MGMT_802_1X	 = 0x01
IW_AUTH_KEY_MGMT_PSK	    = 0x02


#Och konstanterna...
#include/NetworkManager.h
###################################################

# 802.11 wireless-specific device capability bits
NM_802_11_CAP_NONE            = 0x00000000
NM_802_11_CAP_PROTO_NONE      = 0x00000001
NM_802_11_CAP_PROTO_WEP       = 0x00000002
NM_802_11_CAP_PROTO_WPA       = 0x00000004
NM_802_11_CAP_PROTO_WPA2      = 0x00000008
NM_802_11_CAP_RESERVED1       = 0x00000010
NM_802_11_CAP_RESERVED2       = 0x00000020
NM_802_11_CAP_KEY_MGMT_PSK    = 0x00000040
NM_802_11_CAP_KEY_MGMT_802_1X = 0x00000080
NM_802_11_CAP_RESERVED3       = 0x00000100
NM_802_11_CAP_RESERVED4       = 0x00000200
NM_802_11_CAP_RESERVED5       = 0x00000400
NM_802_11_CAP_RESERVED6       = 0x00000800
NM_802_11_CAP_CIPHER_WEP40    = 0x00001000
NM_802_11_CAP_CIPHER_WEP104   = 0x00002000
NM_802_11_CAP_CIPHER_TKIP     = 0x00004000
NM_802_11_CAP_CIPHER_CCMP     = 0x00008000


#Om nödvändigt: nm-ap-security.c
WPA2_CCMP_PSK = (NM_802_11_CAP_PROTO_WPA2 | NM_802_11_CAP_CIPHER_CCMP | NM_802_11_CAP_KEY_MGMT_PSK)

WPA2_TKIP_PSK = (NM_802_11_CAP_PROTO_WPA2 | NM_802_11_CAP_CIPHER_TKIP | NM_802_11_CAP_KEY_MGMT_PSK)

WPA2_EAP = (NM_802_11_CAP_PROTO_WPA2 | NM_802_11_CAP_KEY_MGMT_802_1X)

WPA_CCMP_PSK = (NM_802_11_CAP_PROTO_WPA | NM_802_11_CAP_CIPHER_CCMP | NM_802_11_CAP_KEY_MGMT_PSK)

WPA_TKIP_PSK = (NM_802_11_CAP_PROTO_WPA | NM_802_11_CAP_CIPHER_TKIP | NM_802_11_CAP_KEY_MGMT_PSK)

WPA_EAP = (NM_802_11_CAP_PROTO_WPA | NM_802_11_CAP_KEY_MGMT_802_1X)

WEP_WEP104 = (NM_802_11_CAP_PROTO_WEP | NM_802_11_CAP_CIPHER_WEP104)

WEP_WEP40 = (NM_802_11_CAP_PROTO_WEP | NM_802_11_CAP_CIPHER_WEP40)

