
import monitor
from pyNM.constants import ACTIVE, INTERFACE

import gobject            # for timer

UPDATE_TIME = 333   # ms    how often to update speed information

class init:
	def __init__(self, pynm ):
		self.pynm = pynm
		self.__timer = None
		self.__networkSpeed = None
		self.pynm.status_changed.listen( self.on_status_changed )

	def on_status_changed(self, status=False, network=None ):
		if status==ACTIVE:
			self.stop_timer()
			self.__networkSpeed = monitor.Speed( network[INTERFACE] )
			self.__timer = gobject.timeout_add(UPDATE_TIME,self.timer_update)
		else:
			self.__networkSpeed = None
			self.set_inactive()
			self.stop_timer()

	def timer_update(self):
		if self.__networkSpeed:
			(rx,tx) = self.__networkSpeed.getSpeed()
			self.pynm.speed_changed( rx=rx, tx=tx )
			return True

	def stop_timer(self):
		if self.__timer!=None:
			gobject.source_remove(self.__timer)
			self.__timer = None
			self.set_inactive()

	def set_inactive( self ):
		self.pynm.speed_changed( rx=False, tx=False )
