#!/usr/bin/env python
# -*- encoding: utf8
"""
GTK Window
"""

# graphic
import gtk

# pyNetworkManager
import pyNM

import pyNM.diskWireless

import pyNM.gtk2
import pyNM.gtk2.securityui

import pyNM.debug

import pyNM.sysNetworkSpeed

pyNM.debug.set_error_level(9)
pyNM.debug.set_info_level(9)

# Communicate with NM, react on events
pynm = pyNM.init()

# use this for speed check
#pyNM.sysNetworkSpeed.init( pynm )	# much output

# use this for stored configurations
pyNM.diskWireless.init( pynm )

# use this for security questions
pyNM.gtk2.securityui.init( pynm )

# Create an icon showing current status
icon = pyNM.gtk2.Icon( pynm )

# Create a menu, plopping up on mouse button pressed
menu = pyNM.gtk2.Menu( pynm )

# Create button and add icon to it
button = gtk.Button()
button.set_image( icon )
button.connect( "clicked", menu.show )
button.show()

# Create tooltip ( bound to speedbars )
pyNM.gtk2.Tooltip( pynm, button )

# Create speedbars
speedbars = pyNM.gtk2.Speedbars( pynm )

# create a table and adds button and speedbars
table = gtk.Table( rows=1, columns=6, homogeneous=True )
table.set_border_width(0)
table.attach( button, 0, 4, 0, 1 )
table.attach( speedbars.barTx, 4, 5, 0, 1 )
table.attach( speedbars.barRx, 5, 6, 0, 1 )
table.show()

# create a window and put table in there
window = gtk.Window(gtk.WINDOW_TOPLEVEL)
window.connect( "destroy", pynm.stop )
window.set_default_size(150,150)
window.set_border_width(10)
window.add( table )
window.show()

# Ready. Start plugin
pynm.run()

"""
# for debugging
def show(**args):
	for (key,val) in args.iteritems():
		print key,val
"""